// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AdvFormula.pas' rev: 3.00

#ifndef AdvFormulaHPP
#define AdvFormulaHPP
#include <StdCtrls.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Advformula
{
//-- type declarations -------------------------------------------------------
enum TokenType { Delimiter, Non, variable, Digit, endExpr, Error, Func };

struct TokenRec;
typedef TokenRec *TokenPtr;

struct TokenRec
{
	TokenRec *Next;
	short Start;
	short Close;
} ;

typedef void __fastcall (__closure *TIsCustomFunction)(System::TObject* sender, System::AnsiString &
	func, bool &match);

typedef void __fastcall (__closure *TCalcCustomFunction)(System::TObject* sender, System::AnsiString 
	&func, double &param);

typedef void __fastcall (__closure *TIsCompRefEvent)(System::TObject* sender, System::AnsiString compname
	, Stdctrls::TCustomEdit* compobj);

typedef double TExpressionVariables[101];

class DELPHICLASS TAdvFormula;
class PASCALIMPLEMENTATION TAdvFormula : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int i;
	int varlen;
	Classes::TComponent* fOwner;
	System::AnsiString fExpression;
	int fErrorPosition;
	TIsCustomFunction fIsCustomFunction;
	TCalcCustomFunction fCalcCustomFunction;
	TIsCompRefEvent fIsCompRefEvent;
	System::AnsiString __fastcall ReadWord();
	double __fastcall ReadNumber(void);
	void __fastcall SkipBlanks(void);
	TokenType __fastcall GetToken(void);
	bool __fastcall MatchFunc(System::AnsiString Match, double &Res, TokenType &n);
	bool __fastcall MatchToken(System::AnsiString Match);
	bool __fastcall doPI(double &r);
	bool __fastcall doE(double &r);
	bool __fastcall DoNow(double &r);
	bool __fastcall DoToday(double &r);
	bool __fastcall DoFrac(double &Res, TokenType &n);
	bool __fastcall DoFact(double &Res, TokenType &n);
	bool __fastcall DoInt(double &Res, TokenType &n);
	bool __fastcall DoChs(double &Res, TokenType &n);
	bool __fastcall DoSin(double &Res, TokenType &n);
	bool __fastcall DoCos(double &Res, TokenType &n);
	bool __fastcall DoTan(double &res, TokenType &n);
	bool __fastcall DoCoTan(double &res, TokenType &n);
	bool __fastcall DoSinh(double &Res, TokenType &n);
	bool __fastcall DoCosh(double &Res, TokenType &n);
	bool __fastcall DoTanh(double &res, TokenType &n);
	bool __fastcall DoCoTanh(double &res, TokenType &n);
	bool __fastcall DoMonth(double &res, TokenType &n);
	bool __fastcall DoYear(double &res, TokenType &n);
	bool __fastcall DoDay(double &res, TokenType &n);
	bool __fastcall DoDayOfWeek(double &res, TokenType &n);
	bool __fastcall DoMinute(double &res, TokenType &n);
	bool __fastcall DoSecond(double &res, TokenType &n);
	bool __fastcall DoHour(double &res, TokenType &n);
	bool __fastcall DoExp(double &Res, TokenType &n);
	bool __fastcall DoLn(double &res, TokenType &n);
	bool __fastcall DoLog10(double &res, TokenType &n);
	bool __fastcall DoLog2(double &res, TokenType &n);
	bool __fastcall DoAbs(double &res, TokenType &n);
	bool __fastcall DoArcTan(double &res, TokenType &n);
	bool __fastcall DoArcCoTan(double &res, TokenType &n);
	bool __fastcall DoRound(double &res, TokenType &n);
	bool __fastcall DoTrunc(double &res, TokenType &n);
	bool __fastcall DoDegrees(double &res, TokenType &n);
	bool __fastcall DoRadians(double &res, TokenType &n);
	bool __fastcall DoRand(double &res, TokenType &n);
	bool __fastcall DoSqr(double &res, TokenType &n);
	bool __fastcall DoCube(double &res, TokenType &n);
	bool __fastcall DoSqrt(double &res, TokenType &n);
	bool __fastcall DoArcSin(double &res, TokenType &n);
	bool __fastcall DoArcCos(double &res, TokenType &n);
	void __fastcall DoFunc(double &res, TokenType &n);
	void __fastcall Primitive(double &res, TokenType &n);
	double __fastcall Sign(double Number);
	void __fastcall Level6(double &res, TokenType &n);
	void __fastcall Level5(double &res, TokenType &n);
	void __fastcall Level4(double &res, TokenType &n);
	void __fastcall Level3(double &res, TokenType &n);
	void __fastcall Level2(double &res, TokenType &n);
	void __fastcall Level1(double &res, TokenType &n);
	double __fastcall GetExpr(bool &Valid);
	void __fastcall DoErr(TokenType &n);
	void __fastcall GetNextVar(System::AnsiString &full, System::AnsiString &expr, System::AnsiString &
		c, System::AnsiString &r);
	bool __fastcall IsExprVar(void);
	double __fastcall GetExprVar(void);
	bool __fastcall IsCompRefFunc(System::AnsiString match);
	bool __fastcall SolveCompRefFunc(System::AnsiString match, double &res);
	
public:
	double V[101];
	__fastcall TAdvFormula(Classes::TComponent* aOwner);
	__fastcall virtual ~TAdvFormula(void);
	__property System::AnsiString Expression = {read=fExpression, write=fExpression};
	__property int ErrorPosition = {read=fErrorPosition, write=fErrorPosition, nodefault};
	bool __fastcall Calc(double &r);
	
__published:
	__property TIsCustomFunction IsCustomFunction = {read=fIsCustomFunction, write=fIsCustomFunction};
	__property TCalcCustomFunction CalcCustomFunction = {read=fCalcCustomFunction, write=fCalcCustomFunction
		};
	__property TIsCompRefEvent OnIsCompRef = {read=fIsCompRefEvent, write=fIsCompRefEvent};
};

//-- var, const, procedure ---------------------------------------------------
#define MAXVARS (Byte)(100)

}	/* namespace Advformula */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Advformula;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// AdvFormula
